package com.fjhx.utils;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.SneakyThrows;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class HxBeanUtil {


    /**
     * 复制出一个自定义 recordList<T> 的新page对象
     *
     * @param page 分页对象
     * @return 新 page <Map < String, Object> > 对象
     */
    @SneakyThrows
    public static Page<Map<String, Object>> copyPageEx(IPage<?> page) {
        Page<Map<String, Object>> result = new Page<>();
        // 赋值分页对象基本属性
        copyPageInfo(result, page);
        List<Map<String, Object>> recordList = new ArrayList<>();
        for (Object record : page.getRecords()) {
            Map<String, Object> map = BeanUtil.beanToMap(record);
            recordList.add(map);
        }
        result.setRecords(recordList);
        return result;
    }


    /**
     * 复制出一个自定义 recordList<T> 的新page对象
     *
     * @param page 分页对象
     * @param cls  T
     * @return 新 page <T> 对象
     */
    @SneakyThrows
    public static <T> Page<T> copyPageEx(Page<?> page, Class<T> cls) {
        Page<T> result = new Page<>();
        // 赋值分页对象基本属性
        copyPageInfo(result, page);
        List<T> recordList = new ArrayList<>();
        for (Object record : page.getRecords()) {
            T t = BeanUtil.toBean(record, cls);
            recordList.add(t);
        }
        result.setRecords(recordList);
        return result;
    }

    /**
     * 赋值分页对象基本属性
     *
     * @param result 结果值
     * @param page   入参
     */
    private static void copyPageInfo(Page<?> result, IPage<?> page) {
        result.setTotal(page.getTotal());
        result.setSize(page.getSize());
        result.setCurrent(page.getCurrent());
    }

}
